clear all;
global x_t y_t t k;
OPTIONS = optimset('MaxFunEvals',600,'Maxiter',100,'TolFun',1e-12);

anp = ' & ';
dslash = ' \\ ';
hline = ' \hline ';
bf = ' \bf ';
leftp = '(';
rightp = ')';

data = dlmread('annual_data.csv',',');
t = size(data,1);

for i=1:8


y = data(max(i-5,1):t,3)
n = size(y,1)
control1 = ones(size(y));

x = [data(max(i-5,1):t,3+i) ones(n,1)] 
kv = size(x,2);
beta = inv(x'*x)*x'*y;
pred = x*beta; 
e2 = y - x*beta; 
ss = y'*(eye(n) - control1*inv(control1'*control1)*control1')*y;
rsq = 1 - ((e2'*e2/(n-kv))/(ss/(n-1)))
rmse = (e2'*e2/(n-kv))^(0.5);

% Computing Newey-West Standard Errors for beta
 % Calculating main diagonal of var-cov. matrix, correcting for cross correlation
   P0 = x'*diag(diag(e2*e2'))*x;
 % Calculating off-diagonals of var-cov. matrix
   h_1 = diag(diag(e2*e2',1)',1);
   h_1_ = diag(diag(e2*e2',-1)',-1);
   P1a = x'*h_1*x;
   P1b = x'*h_1_*x;

   h_2 = diag(diag(e2*e2',2)',2);
   h_2_ = diag(diag(e2*e2',-2)',-2);
   P2a = x'*h_2*x;
   P2b = x'*h_2_*x;

   h_3 = diag(diag(e2*e2',3)',3);
   h_3_ = diag(diag(e2*e2',-3)',-3);
   P3a = x'*h_3*x;
   P3b = x'*h_3_*x;

   h_4 = diag(diag(e2*e2',4)',4);
   h_4_ = diag(diag(e2*e2',-4)',-4);
   P4a = x'*h_4*x;
   P4b = x'*h_4_*x;

   h_5 = diag(diag(e2*e2',5)',5);
   h_5_ = diag(diag(e2*e2',-5)',-5);
   P5a = x'*h_5*x;
   P5b = x'*h_5_*x;

   h_6 = diag(diag(e2*e2',6)',6);
   h_6_ = diag(diag(e2*e2',-6)',-6);
   P6a = x'*h_6*x;
   P6b = x'*h_6_*x;

   h_7 = diag(diag(e2*e2',7)',7);
   h_7_ = diag(diag(e2*e2',-7)',-7);
   P7a = x'*h_7*x;
   P7b = x'*h_7_*x;

   h_8 = diag(diag(e2*e2',8)',8);
   h_8_ = diag(diag(e2*e2',-8)',-8);
   P8a = x'*h_8*x;
   P8b = x'*h_8_*x;

omega = P0 + ((1/2)*P1a) + ((1/2)*P1b);
%omega = P0 + ((2/3)*P1a) + ((2/3)*P1b) + ((1/3)*P2a) + ((1/3)*P2b);
%omega = P0 + ((4/5)*P1a) + ((4/5)*P1b) + ((3/5)*P2a) + ((3/5)*P2b) + ((2/5)*P3a) + ((2/5)*P3b) + ((1/5)*P4a) + ((1/5)*P4b);
%omega = P0 + ((8/9)*P1a) + ((8/9)*P1b) + ((7/9)*P2a) + ((7/9)*P2b) + ((6/9)*P3a) + ((6/9)*P3b) + ((5/9)*P4a) + ((5/9)*P4b) + ((4/9)*P5a) + ((4/9)*P5b) + ((3/9)*P6a) + ((3/9)*P6b) + ((2/9)*P7a) + ((2/9)*P7b) + ((1/9)*P8a) + ((1/9)*P8b);
asyvarc = inv(x'*x)*omega*inv(x'*x);
se_newey = diag(asyvarc).^(1/2);
asyvar = inv(x'*x)*P0*inv(x'*x);
se_white = diag(asyvar).^(1/2);
se_ols = (diag(sum(e2'*e2)/(n-kv)*inv(x'*x))).^(1/2);
[beta'; se_ols'; se_white'; se_newey']
beta2 = beta;
asyvar2 = asyvar;
asyvarc2 = asyvarc;

out(1+(i-1)*2,1:2) = [beta(1) rsq];
out(2+(i-1)*2,1:2) = [se_newey(1) 0];

y = data(max(i-5,1):t,2)
n = size(y,1);

kv = size(x,2);
beta = inv(x'*x)*x'*y;
pred = x*beta; 
e4 = y - x*beta; 
ss = y'*(eye(n) - control1*inv(control1'*control1)*control1')*y;
rsq = 1 - ((e4'*e4/(n-kv))/(ss/(n-1)))
rmse = (e4'*e4/(n-kv))^(0.5);

% Computing Newey-West Standard Errors for beta
 % Calculating main diagonal of var-cov. matrix, correcting for cross correlation
   P0 = x'*diag(diag(e4*e4'))*x;
 % Calculating off-diagonals of var-cov. matrix
   h_1 = diag(diag(e4*e4',1)',1);
   h_1_ = diag(diag(e4*e4',-1)',-1);
   P1a = x'*h_1*x;
   P1b = x'*h_1_*x;

   h_2 = diag(diag(e4*e4',2)',2);
   h_2_ = diag(diag(e4*e4',-2)',-2);
   P2a = x'*h_2*x;
   P2b = x'*h_2_*x;

   h_3 = diag(diag(e4*e4',3)',3);
   h_3_ = diag(diag(e4*e4',-3)',-3);
   P3a = x'*h_3*x;
   P3b = x'*h_3_*x;

   h_4 = diag(diag(e4*e4',4)',4);
   h_4_ = diag(diag(e4*e4',-4)',-4);
   P4a = x'*h_4*x;
   P4b = x'*h_4_*x;

   h_5 = diag(diag(e4*e4',5)',5);
   h_5_ = diag(diag(e4*e4',-5)',-5);
   P5a = x'*h_5*x;
   P5b = x'*h_5_*x;

   h_6 = diag(diag(e4*e4',6)',6);
   h_6_ = diag(diag(e4*e4',-6)',-6);
   P6a = x'*h_6*x;
   P6b = x'*h_6_*x;

   h_7 = diag(diag(e4*e4',7)',7);
   h_7_ = diag(diag(e4*e4',-7)',-7);
   P7a = x'*h_7*x;
   P7b = x'*h_7_*x;

   h_8 = diag(diag(e4*e4',8)',8);
   h_8_ = diag(diag(e4*e4',-8)',-8);
   P8a = x'*h_8*x;
   P8b = x'*h_8_*x;

omega = P0 + ((1/2)*P1a) + ((1/2)*P1b);
%omega = P0 + ((2/3)*P1a) + ((2/3)*P1b) + ((1/3)*P2a) + ((1/3)*P2b);
%omega = P0 + ((4/5)*P1a) + ((4/5)*P1b) + ((3/5)*P2a) + ((3/5)*P2b) + ((2/5)*P3a) + ((2/5)*P3b) + ((1/5)*P4a) + ((1/5)*P4b);
%omega = P0 + ((8/9)*P1a) + ((8/9)*P1b) + ((7/9)*P2a) + ((7/9)*P2b) + ((6/9)*P3a) + ((6/9)*P3b) + ((5/9)*P4a) + ((5/9)*P4b) + ((4/9)*P5a) + ((4/9)*P5b) + ((3/9)*P6a) + ((3/9)*P6b) + ((2/9)*P7a) + ((2/9)*P7b) + ((1/9)*P8a) + ((1/9)*P8b);
asyvarc = inv(x'*x)*omega*inv(x'*x);
se_newey = diag(asyvarc).^(1/2);
asyvar = inv(x'*x)*P0*inv(x'*x);
se_white = diag(asyvar).^(1/2);
se_ols = (diag(sum(e4'*e4)/(n-kv)*inv(x'*x))).^(1/2);
[beta'; se_ols'; se_white'; se_newey']
beta4 = beta;
asyvar4 = asyvar;
asyvarc4 = asyvarc;

out(1+(i-1)*2,3:4) = [beta(1) rsq];
out(2+(i-1)*2,3:4) = [se_newey(1) 0];


% Testing equality of sum of coefficients from regressions 2 and 4
summer_diff_24 = [-1; 0; 1; 0];
beta_diff_24 = summer_diff_24'*[beta2; beta4]

% OLS:
asyvar_ols_24 = [sum(e2'*e2)/(n-kv)*inv(x'*x) sum(e2'*e4)/(n-kv)*inv(x'*x); sum(e4'*e2)/(n-kv)*inv(x'*x) sum(e4'*e4)/(n-kv)*inv(x'*x)];
se_ols_beta_diff_24 = (summer_diff_24'*asyvar_ols_24*summer_diff_24)^(0.5)

% White and Newey-West:
 % Calculating main diagonal of var-cov. matrix, correcting for cross correlation
   P0 = x'*diag(diag(e2*e4'))*x;
 % Calculating off-diagonals of var-cov. matrix
   h_1 = diag(diag(e2*e4',1)',1);
   h_1_ = diag(diag(e2*e4',-1)',-1);
   P1a = x'*h_1*x;
   P1b = x'*h_1_*x;

   h_2 = diag(diag(e2*e4',2)',2);
   h_2_ = diag(diag(e2*e4',-2)',-2);
   P2a = x'*h_2*x;
   P2b = x'*h_2_*x;

   h_3 = diag(diag(e2*e4',3)',3);
   h_3_ = diag(diag(e2*e4',-3)',-3);
   P3a = x'*h_3*x;
   P3b = x'*h_3_*x;

   h_4 = diag(diag(e2*e4',4)',4);
   h_4_ = diag(diag(e2*e4',-4)',-4);
   P4a = x'*h_4*x;
   P4b = x'*h_4_*x;

   h_5 = diag(diag(e2*e4',5)',5);
   h_5_ = diag(diag(e2*e4',-5)',-5);
   P5a = x'*h_5*x;
   P5b = x'*h_5_*x;

   h_6 = diag(diag(e2*e4',6)',6);
   h_6_ = diag(diag(e2*e4',-6)',-6);
   P6a = x'*h_6*x;
   P6b = x'*h_6_*x;

   h_7 = diag(diag(e2*e4',7)',7);
   h_7_ = diag(diag(e2*e4',-7)',-7);
   P7a = x'*h_7*x;
   P7b = x'*h_7_*x;

   h_8 = diag(diag(e2*e4',8)',8);
   h_8_ = diag(diag(e2*e4',-8)',-8);
   P8a = x'*h_8*x;
   P8b = x'*h_8_*x;

%omega = P0;   
omega = P0 + ((1/2)*P1a) + ((1/2)*P1b);
%omega = P0 + ((2/3)*P1a) + ((2/3)*P1b) + ((1/3)*P2a) + ((1/3)*P2b);
%omega = P0 + ((4/5)*P1a) + ((4/5)*P1b) + ((3/5)*P2a) + ((3/5)*P2b) + ((2/5)*P3a) + ((2/5)*P3b) + ((1/5)*P4a) + ((1/5)*P4b);
%omega = P0 + ((8/9)*P1a) + ((8/9)*P1b) + ((7/9)*P2a) + ((7/9)*P2b) + ((6/9)*P3a) + ((6/9)*P3b) + ((5/9)*P4a) + ((5/9)*P4b) + ((4/9)*P5a) + ((4/9)*P5b) + ((3/9)*P6a) + ((3/9)*P6b) + ((2/9)*P7a) + ((2/9)*P7b) + ((1/9)*P8a) + ((1/9)*P8b);
asyvar24 = inv(x'*x)*P0*inv(x'*x);
asyvarc24 = inv(x'*x)*omega*inv(x'*x);

 % Calculating main diagonal of var-cov. matrix, correcting for cross correlation
   P0 = x'*diag(diag(e4*e2'))*x;
 % Calculating off-diagonals of var-cov. matrix
   h_1 = diag(diag(e4*e2',1)',1);
   h_1_ = diag(diag(e4*e2',-1)',-1);
   P1a = x'*h_1*x;
   P1b = x'*h_1_*x;

   h_2 = diag(diag(e4*e2',2)',2);
   h_2_ = diag(diag(e4*e2',-2)',-2);
   P2a = x'*h_2*x;
   P2b = x'*h_2_*x;

   h_3 = diag(diag(e4*e2',3)',3);
   h_3_ = diag(diag(e4*e2',-3)',-3);
   P3a = x'*h_3*x;
   P3b = x'*h_3_*x;

   h_4 = diag(diag(e4*e2',4)',4);
   h_4_ = diag(diag(e4*e2',-4)',-4);
   P4a = x'*h_4*x;
   P4b = x'*h_4_*x;

   h_5 = diag(diag(e4*e2',5)',5);
   h_5_ = diag(diag(e4*e2',-5)',-5);
   P5a = x'*h_5*x;
   P5b = x'*h_5_*x;

   h_6 = diag(diag(e4*e2',6)',6);
   h_6_ = diag(diag(e4*e2',-6)',-6);
   P6a = x'*h_6*x;
   P6b = x'*h_6_*x;

   h_7 = diag(diag(e4*e2',7)',7);
   h_7_ = diag(diag(e4*e2',-7)',-7);
   P7a = x'*h_7*x;
   P7b = x'*h_7_*x;

   h_8 = diag(diag(e4*e2',8)',8);
   h_8_ = diag(diag(e4*e2',-8)',-8);
   P8a = x'*h_8*x;
   P8b = x'*h_8_*x;

%omega = P0;   
%omega = P0 + ((1/2)*P1a) + ((1/2)*P1b);
omega = P0 + ((2/3)*P1a) + ((2/3)*P1b) + ((1/3)*P2a) + ((1/3)*P2b);
%omega = P0 + ((4/5)*P1a) + ((4/5)*P1b) + ((3/5)*P2a) + ((3/5)*P2b) + ((2/5)*P3a) + ((2/5)*P3b) + ((1/5)*P4a) + ((1/5)*P4b);
%omega = P0 + ((8/9)*P1a) + ((8/9)*P1b) + ((7/9)*P2a) + ((7/9)*P2b) + ((6/9)*P3a) + ((6/9)*P3b) + ((5/9)*P4a) + ((5/9)*P4b) + ((4/9)*P5a) + ((4/9)*P5b) + ((3/9)*P6a) + ((3/9)*P6b) + ((2/9)*P7a) + ((2/9)*P7b) + ((1/9)*P8a) + ((1/9)*P8b);
asyvar42 = inv(x'*x)*P0*inv(x'*x);
asyvarc42 = inv(x'*x)*omega*inv(x'*x);

asyvar_24 = [asyvar2 asyvar24; asyvar42 asyvar4];
se_white_beta_diff_24 = (summer_diff_24'*asyvar_24*summer_diff_24)^(0.5)

asyvarc_24 = [asyvarc2 asyvarc24; asyvarc42 asyvarc4];
se_newey_beta_diff_24 = (summer_diff_24'*asyvarc_24*summer_diff_24)^(0.5)
test_newey_beta_diff_24 = beta_diff_24'*((summer_diff_24'*asyvarc_24*summer_diff_24)^(-1))*beta_diff_24
pvalue_newey_beta_diff_24 = 1-chi2cdf(test_newey_beta_diff_24,1)
pvalue_newey_beta_diff_24f = 1-fcdf(test_newey_beta_diff_24,1,n-kv)

out(1+(i-1)*2,5) = pvalue_newey_beta_diff_24;

end


out_row1 = [' $log(SP500_t/SP500_{t-1})$ ' anp bf num2str(out(1,2),'%3.2f') anp bf num2str(out(1,4),'%3.2f') anp bf num2str(out(1,1),'%3.2f') anp bf num2str(out(1,3),'%3.2f') anp num2str(out(1,5),'%3.2f') dslash anp anp anp leftp num2str(out(2,1),'%3.2f') rightp anp leftp num2str(out(2,3),'%3.2f') rightp anp dslash]
out_row2 = [' $log(SP500_{t-1}/SP500_{t-2})$ ' anp bf num2str(out(3,2),'%3.2f') anp bf num2str(out(3,4),'%3.2f') anp bf num2str(out(3,1),'%3.2f') anp bf num2str(out(3,3),'%3.2f') anp num2str(out(3,5),'%3.2f') dslash anp anp anp leftp num2str(out(4,1),'%3.2f') rightp anp leftp num2str(out(4,3),'%3.2f') rightp anp dslash]
out_row6= [' $U_{t} - U_{t-1}$ ' anp bf num2str(out(5,2),'%3.2f') anp bf num2str(out(5,4),'%3.2f') anp bf num2str(out(5,1),'%3.2f') anp bf num2str(out(5,3),'%3.2f') anp num2str(out(5,5),'%3.2f') dslash anp anp anp leftp num2str(out(6,1),'%3.2f') rightp anp leftp num2str(out(6,3),'%3.2f') rightp anp dslash]
out_row7 = [' $E_{t}^{household}/E_{t-1}^{household}$ ' anp bf num2str(out(7,2),'%3.2f') anp bf num2str(out(7,4),'%3.2f') anp bf num2str(out(7,1),'%3.2f') anp bf num2str(out(7,3),'%3.2f') anp num2str(out(7,5),'%3.2f') dslash anp anp anp leftp num2str(out(8,1),'%3.2f') rightp anp leftp num2str(out(8,3),'%3.2f') rightp anp dslash]
out_row8 = [' $ISM_t^{manuf.}$ ' anp bf num2str(out(9,2),'%3.2f') anp bf num2str(out(9,4),'%3.2f') anp bf num2str(out(9,1),'%3.2f') anp bf num2str(out(9,3),'%3.2f') anp num2str(out(9,5),'%3.2f') dslash anp anp anp leftp num2str(out(10,1),'%3.2f') rightp anp leftp num2str(out(10,3),'%3.2f') rightp anp dslash]
out_row5 = [' $r_{t-2}^{Treas.(10yr)} - r_{t-2}^{Treas.(2yr)}$ ' anp bf num2str(out(11,2),'%3.2f') anp bf num2str(out(11,4),'%3.2f') anp bf num2str(out(11,1),'%3.2f') anp bf num2str(out(11,3),'%3.2f') anp num2str(out(11,5),'%3.2f') dslash anp anp anp leftp num2str(out(12,1),'%3.2f') rightp anp leftp num2str(out(12,3),'%3.2f') rightp anp dslash]
out_row3 = [' $r_{t}^{HY corporate} - r_{t}^{Treas.(7yr)}$ ' anp bf num2str(out(13,2),'%3.2f') anp bf num2str(out(13,4),'%3.2f') anp bf num2str(out(13,1),'%3.2f') anp bf num2str(out(13,3),'%3.2f') anp num2str(out(13,5),'%3.2f') dslash anp anp anp leftp num2str(out(14,1),'%3.2f') rightp anp leftp num2str(out(14,3),'%3.2f') rightp anp dslash]
out_row4 = [' $r_{t-1}^{HY corporate} - r_{t-1}^{Treas.(7yr)}$ ' anp bf num2str(out(15,2),'%3.2f') anp bf num2str(out(15,4),'%3.2f') anp bf num2str(out(15,1),'%3.2f') anp bf num2str(out(15,3),'%3.2f') anp num2str(out(15,5),'%3.2f') dslash anp anp anp leftp num2str(out(16,1),'%3.2f') rightp anp leftp num2str(out(16,3),'%3.2f') rightp anp dslash]
out_table = [out_row1 out_row2 out_row3 out_row4 out_row5 out_row6 out_row7 out_row8];
dlmwrite('table_LoSE_annual.txt',out_table,'');


